\environment entorn

\starttext

\startsubject[title={Operacions amb nombres naturals}]

\startsubsubject[title={Preguntes}]

<%

exercicis = Hash.new

%>

<%# Exercici 1 %>
<%
exercicis[1] = Array.new

for i in (1...2)
  parametres = Hash.new
  parametres['a'] = rand(2..10)
  parametres['b'] = parametres['a'] + rand(1..10)
  parametres['c'] = parametres['b'] + rand(1..20)
  parametres['d'] = parametres['c'] + rand(1..20)
  
  # Els orden de major a menor: a, b, c, d
  
  exercicis[1].push(parametres)
end
%>

\startexercici[reference=exercici-1] Opereu:
\startitemize[a, columns]
<% exercicis[1].each do |par| %>
\item $<%=par['d']%> + <%=par['a']%> \cdot <%=par['b']%> - <%=par['a']%>$
\item $\left( <%=par['d']%> + <%=par['c']%> \right) \cdot \left(<%=par['d']%> - <%=par['a']%>\right)$
\item $10 \cdot (<%=3*par['d']%>-<%=3*par['b']%>)\div 3 + <%=par['a']%>$
\item $<%=par['c']*par['a']*2+par['b']*par['a']*2%>\div (<%=par['a']%>+<%=par['a']%>) + <%=par['c']%> \cdot (<%=par['c']%>-<%=par['a']%>)$
\item $<%=par['a']%> \cdot (<%=par['b']%>+ <%=par['d']%>\cdot <%=par['c']%>)$
\item $<%=par['a']%> + \left(<%=par['c']%> + <%=par['c']%> \cdot \left(<%=par['b']%>+<%=par['d']%> \right)\right)$
<% end %>
\stopitemize
\stopexercici



<%# Exercici 2 %>
<%
exercicis[2] = Array.new

for i in (1...2)
  parametres = Hash.new
  
  parametres['a'] = rand(2..20)
  parametres['b'] = rand(2..20)
  parametres['c'] = rand(2..20)
  parametres['d'] = rand(2..20)
  exercicis[2].push(parametres)
end
%>


\startexercici[reference=exercici-2] Opereu:
<% exercicis[2].each do |par| %>
\startformula
<%=2*par['a']%> \cdot <%=3*par['b']%> \div <%=par['a']%> \cdot <%=par['a']%> \div <%=par['b']%> + \left(<%=par['c']%> + <%=par['d']%> \right) \cdot <%=par['d']%>
\stopformula
<% end %>
\stopexercici

\stopsubsubject


<%# ----------------------- Solucions ------------------------ %>
\page[yes]
\startsubsubject[title={Solucions}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
\item $<%=par['d'] + par['a'] * par['b'] - par['a']%>$

\item $ <%= (par['d']  + par['c']) * ( par['d']  - par['a']) %>$

\item $<%= 10 * (3*par['d'] - 3*par['b']) / 3 + par['a']%>$

\item $<%= (par['c']*par['a']*2+par['b']*par['a']*2) / (par['a']+par['a']) + par['c'] *  (par['c'] - par['a'])%>$

\item $<%= par['a'] * (par['b'] + par['d'] * par['c'])%>$

\item $<%= par['a'] + ( par['c'] + par['c'] * (par['b'] + par['d']) )%>$

<% end %>
\stopitemize

\sym{\in[exercici-2]}
<% exercicis[2].each do |par| %>
<% 
   solucio = 2*par['a']*3*par['b'] / par['a'] * par['a'] / par['b'] + (par['c'] + par['d']) * par['d']

%>
$<%=solucio%>$
<% end %>


\stopitemize

\vfill
Les solucions d'aquests exercicis s'han calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

<%# ----------------------- Resolució ------------------------ %>
\page[yes]
\startsubsubject[title={Resolució}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
%>

\item \startformula
\startalign
 \NC \NC <%=par['d']%> + <%=par['a']%> \cdot <%=par['b']%> - <%=par['a']%> \NR
 \NC = \NC <%=par['d']%> + <%=par['a'] * par['b']%> - <%=par['a']%> \NR
 \NC = \NC <%=par['d']  + par['a'] * par['b']%> - <%=par['a']%> \NR
 \NC = \NC <%=par['d']  + par['a'] * par['b'] - par['a']%>
\stopalign
\stopformula

\item \startformula
\startalign
 \NC \NC \left( <%=par['d']%> + <%=par['c']%> \right) \cdot \left(<%=par['d']%> - <%=par['a']%>\right) \NR
 \NC = \NC <%= (par['d'] + par['c']) %> \cdot <%=(par['d'] - par['a'])%> \NR
 \NC = \NC <%= (par['d'] + par['c']) * (par['d'] - par['a'])%> 
\stopalign
\stopformula

\item \startformula
\startalign
 \NC \NC 10 \cdot (<%=3*par['d']%>-<%=3*par['b']%>)\div 3 + <%=par['a']%> \NR
 \NC = \NC 10 \cdot <%=3*par['d'] - 3*par['b']%> \div 3 + <%=par['a']%> \NR
 \NC = \NC <%= 10 * (3*par['d'] - 3*par['b']) %> \div 3 + <%=par['a']%> \NR
 \NC = \NC <%= 10 * (3*par['d'] - 3*par['b']) / 3 %> + <%=par['a']%> \NR
 \NC = \NC <%= 10 * (3*par['d'] - 3*par['b']) / 3 + par['a']%>
\stopalign
\stopformula

\item \startformula
\startalign
 \NC \NC <%=par['c']*par['a']*2+par['b']*par['a']*2%>\div (<%=par['a']%>+<%=par['a']%>) + <%=par['c']%> \cdot (<%=par['c']%>-<%=par['a']%>) \NR
 \NC = \NC <%=par['c']*par['a']*2+par['b']*par['a']*2%>\div <%=(par['a'] + par['a'])%> + <%=par['c']%> \cdot <%=(par['c'] - par['a'])%> \NR 
 \NC = \NC <%=(par['c']*par['a']*2+par['b']*par['a']*2)/ (par['a'] + par['a'])%> + <%=par['c'] * (par['c'] - par['a'])%> \NR 
 \NC = \NC <%=(par['c']*par['a']*2+par['b']*par['a']*2)/ (par['a'] + par['a'])  + par['c'] * (par['c'] - par['a'])%>
\stopalign
\stopformula

\item \startformula
\startalign
 \NC \NC <%=par['a']%> \cdot (<%=par['b']%>+ <%=par['d']%>\cdot <%=par['c']%>) \NR
 \NC = \NC <%=par['a']%> \cdot (<%=par['b']%>+ <%=par['d'] * par['c']%>) \NR
 \NC = \NC <%=par['a']%> \cdot (<%=par['b'] + par['d'] * par['c']%>) \NR
 \NC = \NC <%=par['a'] * (par['b'] + par['d'] * par['c'])%>
\stopalign
\stopformula

\item \startformula
\startalign
  \NC \NC <%=par['a']%> + \left(<%=par['c']%> + <%=par['c']%> \cdot \left(<%=par['b']%>+<%=par['d']%> \right)\right) \NR
  \NC = \NC <%=par['a']%> + \left(<%=par['c']%> + <%=par['c']%> \cdot <%=par['b'] + par['d']%> \right) \NR
  \NC = \NC <%=par['a']%> + \left(<%=par['c']%> + <%=par['c'] * (par['b'] + par['d']) %> \right) \NR
  \NC = \NC <%=par['a']%> + <%=par['c'] + par['c'] * (par['b'] + par['d']) %> \NR
  \NC = \NC <%=par['a']  + (par['c'] + par['c'] * (par['b'] + par['d'])) %>
\stopalign
\stopformula


<% end %>
\stopitemize

\sym{\in[exercici-2]}

<% exercicis[2].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
   solucio = 2*par['a']*3*par['b'] / par['a'] * par['a'] / par['b'] + (par['c'] + par['d']) * par['d']
%>

\startformula
\startalign
\NC \NC <%=2*par['a']%> \cdot <%=3*par['b']%> \div <%=par['a']%> \cdot <%=par['a']%> \div <%=par['b']%> + \left(<%=par['c']%> + <%=par['d']%> \right) \cdot <%=par['d']%> \NR
  \NC = \NC <%=2*par['a']%> \cdot <%=3*par['b']%> \div <%=par['a']%> \cdot <%=par['a']%> \div <%=par['b']%> + <%=par['c'] + par['d']%> \cdot <%=par['d']%> \NR
  \NC = \NC <%=2*par['a'] * 3*par['b']%> \div <%=par['a']%> \cdot <%=par['a']%> \div <%=par['b']%> + <%=(par['c'] + par['d'])*par['d']%> \NR
  \NC = \NC  <%=(2*par['a'] * 3*par['b']) / par['a']%> \cdot <%=par['a']%> \div <%=par['b']%> + <%=(par['c'] + par['d'])*par['d']%> \NR
  \NC = \NC   <%=((2*par['a'] * 3*par['b']) / par['a']) * par['a']%> \div <%=par['b']%> + <%=(par['c'] + par['d'])*par['d']%> \NR
  \NC = \NC  <%=(((2*par['a'] * 3*par['b']) / par['a']) * par['a']) / par['b']%> + <%=(par['c'] + par['d'])*par['d']%> \NR
  \NC  = \NC <%=solucio%>
\stopalign
\stopformula
<% end %>




\stopitemize

\vfill
La resolució d'aquests exercicis s'ha calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

\stopsubject

\stoptext
